<?php

class Uploader
{
	static $PROGRESS_KEY = null;

	function getStatus($id)
	{
		$info = array(
			'id'       => $id,
			'done'     => 0,
			'total'    => 0,
			'complete' => 0
		);

		if (!extension_loaded('apc') || !ini_get('apc.enabled') || !ini_get('apc.rfc1867'))
		{
			return $info;
		}

		$status = apc_fetch(ini_get('apc.rfc1867_prefix') . $id);
		if (is_array($status))
		{
			$info['done']     = $status['done'];
			$info['total']    = $status['total'];
			$info['complete'] = $status['current'];
		}

		return $info;
	}

	function upload($key, $directory)
	{
		if (!isset($_FILES[$key]))
		{
			return -1;
		}

		$file = $_FILES[$key];
		if ($file['error'] != UPLOAD_ERR_OK)
		{
			return -2;
		}

		if (!move_uploaded_file($file['tmp_name'], $directory.'/'.$file['name']))
		{
			return -3;
		}

		return 0;
	}
}
Uploader::$PROGRESS_KEY = ini_get('apc.rfc1867_name');

?>