function addOnLoadEvent(func)
{
	if (typeof (window.addEventListener) != "undefined")
	{
		window.addEventListener( "load", func, false );
	}
	else if ((typeof window.attachEvent) != "undefined")
	{
		window.attachEvent( "onload", func );
	}
	else if ( window.onload != null )
	{
		var oldOnload = window.onload;
		window.onload = function ( e )
		{
			oldOnload( e );
			window[func]();
		}
	}
	else
	{
		window.onload = func;
	}
}

function addEvent(object, event, func)
{
	if(window.addEventListener)
	{
		object.addEventListener(event, func, false);
	}
	else
	{
		object.attachEvent('on'+event, func);
	}
}

function createElement(xmlDoc, element, xmlns)
{
	try
	{
		el = xmlDoc.createElementNS(xmlns, element);
	}
	catch (e)
	{
		el = xmlDoc.createElement(element);
	}
	el.setAttribute('xmlns', xmlns);
	return el;
}

function vypisInfo(text)
{
	var konzola = document.getElementById('uploadConsole');
	var textNode = document.createTextNode(text);
	konzola.appendChild(textNode);
}

function getSrcElement(e)
{
	var out = null;
	if (e.target) out = e.target;
	else if (e.srcElement) out = e.srcElement;
	return out;
}

var UploadForm = function(form)
{
	if (typeof(this.m_nextId) == 'undefined')
	{
		this.m_nextId = 0;
	}
	this.m_nextId++;
	this.m_form   = form;
	this.m_timer  = null;
	this.m_stop   = false;
	this.m_progressBar = null;
	this.m_info   = null;
	this.m_iframe = null;

/*
  Reakcia na odoslanie formulára.
*/
	this.onSubmit = function(e)
	{
		var t = this;
/*
  Po načítaní rámca funkcia iframeLoad presunie jeho obsah do hlavného okna.
*/
		addEvent(this.m_iframe, 'load', function(e) {t.iframeLoad(e);});
		var uploadKey = 'APC_UPLOAD_PROGRESS';
		var statusSite = 'status.php';
		var inputs = getSrcElement(e).form.elements;
		var fileId = null;
		for (var i = 0; i < inputs.length; ++i)
		{
			if (inputs[i].name == uploadKey)
			{
				fileId = inputs[i].value;
			}
		}

		if (fileId == null)
		{
			return;
		}

/*!
  Spustenie monitorovania stavu.
*/
		var startMonitoring = function(fileId)
		{
			var data = 'fid=' + encodeURIComponent(fileId);
			var startTimer = function()
			{
				var xmlhttp = new XMLHttpRequest();
				var onReady = function()
				{
					if (xmlhttp.readyState == 4)
					{
						if (t.m_stop)
						{
							return;
						}
/*!
  Spracovanie XML.
*/
						var xml = xmlhttp.responseXML;
						var doc = xml.documentElement;
						t.m_timer = setTimeout(function() {startTimer();}, 100);
						if (doc == null)
						{
							return;
						}
						var done     = doc.getElementsByTagName('done')[0].firstChild.nodeValue;
						var total    = doc.getElementsByTagName('total')[0].firstChild.nodeValue;
						var complete = doc.getElementsByTagName('complete')[0].firstChild.nodeValue;

						if (done == 1)
						{
							t.stopPool();
						}
						if (total > 0)
						{
							t.m_progressBar.style.width = (complete * 100) / total + '%';
							t.m_info.innerHTML = complete + '/' + total;
						}
					}
				}
				xmlhttp.onreadystatechange = onReady;
				xmlhttp.open('post', statusSite, true);
				xmlhttp.setRequestHeader('Content-Type',
				                         'application/x-www-form-urlencoded; charset=UTF-8');
				xmlhttp.send(data);
			}
			startTimer();
		}
		startMonitoring(fileId);
	}

/*
  Zastavenie dotazovania sa na stav prenosu súboru.
*/
	this.stopPool = function()
	{
		this.m_stop = true;
		if (this.m_timer != null)
		{
			clearTimeout(this.timer);
			this.m_timer = null;
		}
	}

/*
  Po načítaní rámca presunutie jeho obsahu do hlavného okna.
*/
	this.iframeLoad = function(e)
	{
		this.stopPool();
		document.write("<html>" + getSrcElement(e).contentDocument.firstChild.innerHTML + "</html>");
	}

	this.construct = function()
	{
		var t = this;
/*
  Pridané odchytenie udalosti click na tlačítkách.
*/
		var inputs = form.getElementsByTagName('input');
		for (var i = 0; i < inputs.length; ++i)
		{
			if (inputs[i].type == 'submit')
			{
				addEvent(inputs[i], 'click', function(e) {t.onSubmit(e);});
			}
		}
		var frameId = 'uploadFrame_' + i;
		var iframe = createElement(document, 'iframe', 'http://www.w3.org/1999/xhtml');
		iframe.style.width = '1px';
		iframe.style.height = '1px';
		iframe.style.display = 'none';
		iframe.setAttribute('id', frameId);
		this.m_iframe = iframe;
		form.appendChild(iframe);
		/*var frameId = 'uploadFrame';
		this.m_iframe = document.getElementById(frameId);
		form.target = frameId;*/

		var progFrame = createElement(document, 'div', 'http://www.w3.org/1999/xhtml');
		var progBar   = createElement(document, 'div', 'http://www.w3.org/1999/xhtml');

		progFrame.className = 'progFrame';
		progBar.className   = 'progBar';
		progBar.style.width = '0%';
		this.m_progressBar = progBar;

		progFrame.appendChild(progBar);
		form.appendChild(progFrame);

		this.m_info = createElement(document, 'div', 'http://www.w3.org/1999/xhtml');
		form.appendChild(this.m_info);


		//addEvent(iframe, 'load', function(e) {t.iframeLoad(e);});
	}
	this.construct();
}

/*
  Funkcia vykonávajúca sa po načítaní celého dokumentu.
*/
var onLoad = function(e)
{
	/*var iframe = createElement(document, 'iframe', 'http://www.w3.org/1999/xhtml');
	iframe.style.width = '1px';
	iframe.style.height = '1px';
	iframe.style.display = 'none';
	iframe.setAttribute('id', 'uploadFrame');
	document.body.appendChild(iframe);*/

/*
  Vytvorenie elementu pre výpis hlásení.
*/
	var pre = createElement(document, 'pre', 'http://www.w3.org/1999/xhtml');
	pre.setAttribute('id', 'uploadConsole');
	document.body.appendChild(pre);

/*
  Úprava formulárov.
*/
	var forms = document.getElementsByTagName('form');
	for (var i = 0; i < forms.length; ++i)
	{
		var uf = new UploadForm(forms[i]);
	}

}

addOnLoadEvent(onLoad);